
#ifndef _WIN32
#include "../include/lminmaxgd.h"
#else
#include "..\include\lminmaxgd.h"
#endif

/**************************************************************************************/
/* this example present the main function of the library
   and the different manner to declare monomial polynom serie and matrix */
/**************************************************************************************/
using namespace std;

int main(void)
{ 
try{
serie s1,s2, s3, res;
gd p,q,p1,q1,r;
//int i;
poly pol1,pol2,resp;

p.init(2,2);
q.init(5,10);

s1.init(p,epsilon,e);
s2.init(epsilon,q,e);

res = prga(s1,s2);
cout<<"Expected: epsilon. Obtained: "<<res<<endl;

res = prga(s2,s1);
cout<<"Expected: g^5d^2. Obtained: "<<res<<endl;

p.init(2,2);
q.init(4,6);
p1.init(10,15);
q1.init(17,21);
s1.init(p,q,e);
s2.init(p1,q1,e);
s1=oplus(s1,s2);
pol1.init(2,2);
pol1 = oplus(pol1,q);
pol1 = oplus(pol1,p1);
pol1 = oplus(pol1,q1);

q.init(6,5);
p1.init(10,12);
q1.init(20,20);
s3.init(e,q,e);
s2.init(p1,q1,e);
s2=oplus(s3,s2);
pol2.init(0,0);
pol2 = oplus(pol2,q);
pol2 = oplus(pol2,p1);
pol2 = oplus(pol2,q1);

res = prga(s1,s2);
cout<<"Expected: g^2+g^10d^12. Obtained: "<<res<<endl;
resp = prga(pol1,pol2);
cout<<"Expected: g^2+g^10d^12. Obtained: "<<resp<<endl;

resp = prga(pol2,pol1);
cout<<"Expected: g^6d^6+g^10d^15+g^20d^21. Obtained: "<<resp<<endl;
res = prga(s2,s1);
cout<<"Expected: g^6d^6+g^10d^15+g^20d^21. Obtained: "<<res<<endl;




p.init(0,2);
q.init(1,3);
s2.init(epsilon,p,q);
res = prga(s1,s2);
cout<<"Expected: g^2d^8+g^4d^14+g^10d^32+g^17d^53. Obtained: "<<res<<endl;

p.init(0,2);
q.init(5,4);
r.init(2,4);
s2.init(p,q,r);
res = prga(s1,s2);
cout<<"Expected: g^2d^2+g^10d^12+g^17d^28. Obtained: "<<res<<endl;

p.init(0,2);
q.init(3,3);
s1.init(epsilon,p,q);
p.init(0,1);
q.init(2,5);
s2.init(epsilon,p,q);
res = prga(s1,s2);
cout<<"Expected: (d+g^3d^6)(g^6d^15)*. Obtained: "<<res<<endl;

res = prga(s2,s1);
cout<<"Expected: (d^2+g^4d^5)(g^6d^6)*. Obtained: "<<res<<endl;

pol1.init(0,0);
p.init(2,4);
pol1 = oplus(pol1,p);
pol2.init(3,6);
q.init(5,7);
pol2=oplus(pol2,q);
r.init(3,4);
s1.init(pol1,pol2,r);

pol1.init(0,3);
pol2.init(2,4);
q.init(4,6);
pol2=oplus(pol2,q);
r.init(5,5);
s2.init(pol1,pol2,r);
res = prga(s1,s2);
cout<<"Expected: d^3+g^2d^4+g^5d^6+g^8d^9+g^9d^11+g^12d^14+g^14d^16+g^17d^19+g^20d^21+... and throughput 1. Obtained: "<<res<<endl;


res = prga(s2,s1);
cout<<"Expected: e+g^2d^4+g^7d^10+g^9d^14+g^12d^18+g^14d^19+g^17d^23+g^19d^26+g^22d^30+... and throughput 0,75. Obtained: "<<res<<endl;
 }
  catch(mem_limite l)
 {
	 cout<<"Exception : too many coefficent in polynom "<<l.memoire<<endl;
	 return(1);
 }

 catch(taille_incorrecte obj)
 { // 0 : r non causal
   // 1 : tentative d'accs  un element d'une matrice avec un indice incorrect
   // 2 : matrice de taille incompatible pour oplus, inf, otimes, rfrac, lfrac
   // 3 : etoile de matrice carr uniquement	 
	 cout<<"Exception  "<<obj.erreur<<endl;
	 return(1);
 }
}
